; static char *SCCSID = "src/dev/dasd/diskh/aspi.h, aha, r202 92/08/14";  
;***********************************************************************  
;                                                                         
;  Driver Name: OS2ASPI.DMD - OS/2 ASPI Device Manager                    
;               --------------------------------------                    
;                                                                         
;  Source File Name: ASPI.H                                               
;                                                                         
;  Descriptive Name: ASPI External Interface Structures                   
;                                                                         
;  Function: Define ASPI to Device Module shared structures               
;                                                                         
;                                                                         
; ----------------------------------------------------------------------  
;                                                                         
;  Copyright (C) 1992 IBM Corporation                                     
;                                                                         
;  DISCLAIMER OF WARRANTIES.  The following [enclosed] code is            
;  provided to you solely for the purpose of assisting you in             
;  the development of your applications. The code is provided             
;  "AS IS", without warranty of any kind. IBM shall not be liable         
;  for any damages arising out of your use of this code, even if          
;  they have been advised of the possibility of such damages.             
;                                                                         
; ----------------------------------------------------------------------  
;                                                                         
;  Change Log                                                             
;                                                                         
;  Mark    Date      Programmer  Comment                                  
;  ----    ----      ----------  -------                                  
;  @53040  08/14/92  JHL         Define extensions to ASPI for reporting  
;                                residual byte counts and limitations     
;                                on HBA scatter/gather lists.             
;                                                                         
;          06/22/94  JHL/TA      Added support for VASPI (DOS execute     
;                                I/O SRB)                                 
;                                                                         
;  @104639 11/29/94  JHL/TA      ASPI_SRB_ABORT_IO structure defined      
;                                the PPSRB as a UCHAR - should be ULONG   
;***********************************************************************  
ASPI_CMD_LIMIT	EQU	6 
; 
;* ASPI SRB Header

ASPI_SRBHDR	STRUC
ASHD_CommandCode	DB	?
ASHD_ASPIStatus	DB	?
ASHD_AdapterIndex	DB	?
ASHD_ASPIReqFlags	DB	?
ASPI_SRBHDR	ENDS

ASPI_SRB_HEADER EQU ASPI_SRBHDR


; 
;* Command Values in ASPI_SRB_HEADER->CommandCode
ASPI_CMD_ADAPTER_INQUIRY	EQU	00H 
ASPI_CMD_GET_DEVICE_TYPE	EQU	01H 
ASPI_CMD_EXECUTE_IO	EQU	02H 
ASPI_CMD_ABORT_IO	EQU	03H 
ASPI_CMD_RESET_DEVICE	EQU	04H 
ASPI_CMD_SET_ADAPTER_PARMS	EQU	05H 
; 
;* ASPI Status Values in ASPI_SRB_HEADER->ASPIStatus
ASPI_STATUS_IN_PROGRESS	EQU	00H 
ASPI_STATUS_NO_ERROR	EQU	01H 
ASPI_STATUS_ABORTED	EQU	02H 
ASPI_STATUS_ERROR	EQU	04H 
ASPI_STATUS_INVALID_COMMAND	EQU	80H 
ASPI_STATUS_INVALID_ADAPTER	EQU	81H 
ASPI_STATUS_INVALID_TARGET	EQU	82H 
ASPI_STATUS_MANAGER_BUSY	EQU	0E5H 
ASPI_STATUS_BUFFER_TOO_BIG	EQU	0E6H 
; 
;* ASPI Flags in ASPI_SRB_HEADER->ASPIReqFlags
ASPI_REQFLAG_POST_ENABLE	EQU	01H 
ASPI_REQFLAG_LINKED_SRB	EQU	02H 
ASPI_REQFLAG_RESIDUAL	EQU	04H 
ASPI_REQFLAG_DIRECTION_BITS	EQU	18H 
ASPI_REQFLAG_DIR_TO_HOST	EQU	08H 
ASPI_REQFLAG_DIR_TO_TARGET	EQU	10H 
ASPI_REQFLAG_DIR_NO_DATA_XFER	EQU	18H 
ASPI_REQFLAG_SG_ENABLE	EQU	20H 
; 
;* ASPI ADAPTER INQUIRY SRB            (for ASPI_CMD_ADAPTER_INQUIRY)

ASPI_SRB_ADAPTER_INQUIRY	STRUC
ASAI_SRBHdr	DB	SIZE ASPI_SRB_HEADER DUP (?)
ASAI_Reserved_1	DB	4 DUP (?)
ASAI_AdapterCount	DB	?
ASAI_AdapterTargetID	DB	?
ASAI_ManagerName	DB	16 DUP (?)
ASAI_AdapterName	DB	16 DUP (?)
ASAI_AdapterParms	DB	16 DUP (?)
; 
;*New fields for an EXTENDED adapter inquiry                     @V53040
ASAI_AdapterFeatures	DW	?                   ;  @V53040    
ASAI_MaximumSGList	DW	?                     ;  @V53040    
ASAI_MaximumCDBTransfer	DD	?                ;  @V53040    
ASPI_SRB_ADAPTER_INQUIRY	ENDS
; 
;* Number of bytes in the extended fields -  @V53040
MAX_EXTENDED_ADAPTER_COUNT	EQU	08H                             ;  @V53040    
; 
;* Features in ASPI_SRB_ADAPTER_INQUIRY->AdapterFeatures
ASPI_SCATTER_GATHER	EQU	01H                             ;  @V53040    
ASPI_RESIDUAL_BYTE	EQU	02H                             ;  @V53040    
ASPI_ADDRESS_LIMITED	EQU	04H 
; 
;* ASPI GET DEVICE TYPE SRB          (for ASPI_CMD_DEVICE_TYPE)

ASPI_SRB_DEVICE_TYPE	STRUC
ASDT_SRBHdr	DB	SIZE ASPI_SRB_HEADER DUP (?)
ASDT_Reserved_1	DB	4 DUP (?)
ASDT_DeviceTargetID	DB	?
ASDT_DeviceTargetLUN	DB	?
ASDT_DeviceType	DB	?
; New fields for EXTENDED target information  
ASDT_TargetFeatures	DW	?
ASPI_SRB_DEVICE_TYPE	ENDS
; 
;* Number of bytes in the extended fields
MAX_EXTENDED_TARGET_COUNT	EQU	01H 
; 
;* Features in ASPI_SRB_DEVICE_TYPE->TargetFeatures
ASPI_DEVICE_ALLOCATION_SHARED	EQU	01H 
; 
;* ASPI EXECUTE IO SRB               (for ASPI_CMD_EXECUTE_IO)

ASPI_SRB_EXECUTE_IO	STRUC
ASEI_SRBHdr	DB	SIZE ASPI_SRB_HEADER DUP (?)
ASEI_SGListLen	DW	?
ASEI_Reserved_1	DB	2 DUP (?)
ASEI_DeviceTargetID	DB	?
ASEI_DeviceTargetLUN	DB	?
ASEI_DataXferLen	DD	?
ASEI_SenseDataLen	DB	?
ASEI_ppDataBuffer	DD	?
ASEI_ppNxtSRB	DD	?
ASEI_SCSICDBLen	DB	?
ASEI_HostStatus	DB	?
ASEI_TargetStatus	DB	?
ASEI_RM_PostAddress	DD	?
ASEI_RM_DataSeg	DW	?
ASEI_PM_PostAddress	DD	?
ASEI_PM_DataSeg	DW	?
ASEI_ppSRB	DD	?
ASEI_ASPIWorkSpace	DB	22 DUP (?)
ASEI_SCSICDBStart	DB	1 DUP (?)
ASPI_SRB_EXECUTE_IO	ENDS
; 
;* DOS ASPI EXECUTE IO SRB           (for ASPI_CMD_EXECUTE_IO)

DOS_ASPI_SRB_EXECUTE_IO	STRUC
DASEI_SRBHdr	DB	SIZE ASPI_SRB_HEADER DUP (?)
DASEI_Reserved_1	DB	4 DUP (?)
DASEI_DeviceTargetID	DB	?
DASEI_DeviceTargetLUN	DB	?
DASEI_DataXferLen	DD	?
DASEI_SenseDataLen	DB	?
DASEI_pDataBuffer	DD	?
DASEI_pNxtSRB	DD	?
DASEI_SCSICDBLen	DB	?
DASEI_HostStatus	DB	?
DASEI_TargetStatus	DB	?
DASEI_RM_PostAddress	DD	?
DASEI_ASPIWorkSpace	DB	34 DUP (?)
DASEI_SCSICDBStart	DB	1 DUP (?)
DOS_ASPI_SRB_EXECUTE_IO	ENDS
; 
;* Status returned in ASPI_SRB_EXECUTE_IO->HostStatus
ASPI_HSTATUS_NO_ERROR	EQU	00H 
ASPI_HSTATUS_SELECTION_TIMEOUT	EQU	11H 
ASPI_HSTATUS_DATA_OVERRUN	EQU	12H 
ASPI_HSTATUS_BUS_FREE	EQU	13H 
ASPI_HSTATUS_BUS_PHASE_ERROR	EQU	14H 
ASPI_HSTATUS_BAD_SGLIST	EQU	1AH               ;  @V53040    
; 
;* Status returned in ASPI_SRB_EXECUTE_IO->TargetStatus
ASPI_TSTATUS_NO_ERROR	EQU	00H 
ASPI_TSTATUS_CHECK_CONDITION	EQU	02H 
ASPI_TSTATUS_BUSY	EQU	08H 
ASPI_TSTATUS_RESERV_CONFLICT	EQU	18H 
; 
;* ASPI ABORT IO SRB                 (for ASPI_CMD_ABORT_IO)

ASPI_SRB_ABORT_IO	STRUC
ASAB_SRBHdr	DB	SIZE ASPI_SRB_HEADER DUP (?)
ASAB_Reserved_1	DB	4 DUP (?)
ASAB_ppSRB	DD	?                                       ; @104639  
ASPI_SRB_ABORT_IO	ENDS
; 
;* ASPI RESET DEVICE SRB             (for ASPI_RESET_DEVICE)

ASPI_SRB_RESET_DEVICE	STRUC
ASRD_SRBHdr	DB	SIZE ASPI_SRB_HEADER DUP (?)
ASRD_Reserved_1	DB	4 DUP (?)
ASRD_DeviceTargetID	DB	?
ASRD_DeviceTargetLUN	DB	?
ASRD_Reserved_2	DB	14 DUP (?)
ASRD_HostStatus	DB	?
ASRD_TargetStatus	DB	?
ASRD_RM_PostAddress	DD	?
ASRD_RM_DataSeg	DW	?
ASRD_PM_PostAddress	DD	?
ASRD_PM_DataSeg	DW	?
ASRD_ASPIWorkSpace	DB	22 DUP (?)
ASPI_SRB_RESET_DEVICE	ENDS
; 
;* ASPI SET HOST ADAPTER PARAMETERS  (for ASPI_CMD_SET_ADAPTER_PARMS)

ASPI_SRB_ADAPTER_PARMS	STRUC
ASAP_SRBHdr	DB	SIZE ASPI_SRB_HEADER DUP (?)
ASAP_Reserved_1	DB	4 DUP (?)
ASAP_AdapterParms	DB	16 DUP (?)
ASPI_SRB_ADAPTER_PARMS	ENDS
