;**************************************************************************
;*
;* SOURCE FILE NAME =  SCSI.H
;*
;* DESCRIPTIVE NAME =  ADD/DM - Include Files
;*                     SCSI CDB Data Structures and ADD/DM Status Block
;*                     for SCSI Devices
;*
;* Copyright : COPYRIGHT IBM CORPORATION, 1991, 1992
;*             LICENSED MATERIAL - PROGRAM PROPERTY OF IBM
;*             REFER TO COPYRIGHT INSTRUCTION FORM#G120-2083
;*             RESTRICTED MATERIALS OF IBM
;*             IBM CONFIDENTIAL
;*
;* VERSION = V2.0
;*
;* DATE
;*
;* DESCRIPTION :
;*
;* Purpose:
;*
;*
;*
;*
;* FUNCTIONS  :
;*
;*
;*
;* NOTES
;*
;*
;* STRUCTURES
;*
;* EXTERNAL REFERENCES
;*
;*
;*
;* EXTERNAL FUNCTIONS
;*
;* CHANGE ACTIVITY =
;*   DATE      FLAG        APAR   CHANGE DESCRIPTION
;*   --------  ----------  -----  --------------------------------------
;*
;*   06/18/92      RAB            PTR CP20 B736994
;*                                Remove ";" from SCSI_INQ_* defines
;*                                by R. Berkoff
;*
;***************************************************************************  
;  Typedefs to resolve forward references   
; 
;*    General SCSI definitions
; 
;*  SCSI Operation Codes
SCSI_TEST_UNIT_READY	EQU	00H     ;  Test Unit Ready                    
SCSI_REZERO_UNIT	EQU	01H     ;  CD-ROM rezero unit                 
SCSI_REWIND	EQU	01H     ;  Tape Rewind                        
SCSI_REQUEST_SENSE	EQU	03H     ;  Request Sense Command              
SCSI_READ_BLK_LIMITS	EQU	05H     ;  Read Block Limits                  
SCSI_REQ_AUX_SENSE	EQU	06H     ;  Request Auxiliary Sense            
SCSI_REASSIGN_BLOCKS	EQU	07H     ;  Reassign Blocks                    
SCSI_READ_6	EQU	08H     ;  SCSI 6 byte Read                   
SCSI_WRITE_6	EQU	0AH     ;  SCSI 6 byte Write                  
SCSI_SEEK_6	EQU	0BH     ;  SCSI 6 byte Seek                   
SCSI_WRITE_FILEMARKS	EQU	10H     ;  Tape Write Filemarks               
SCSI_SPACE	EQU	11H     ;  Tape Space                         
SCSI_INQUIRY	EQU	12H     ;  Inquiry command                    
SCSI_RECOVER_BUFFER	EQU	14H     ;  Tape Recover Buffer                
SCSI_MODE_SELECT	EQU	15H     ;  Mode Select                        
SCSI_RESERVE_UNIT	EQU	16H     ;  Tape Reserve Unit                  
SCSI_RELEASE_UNIT	EQU	17H     ;  Tape Release Unit                  
SCSI_ERASE	EQU	19H     ;  Tape Erase                         
SCSI_MODE_SENSE	EQU	1AH     ;  Mode Sense                         
SCSI_START_STOP_UNIT	EQU	1BH     ;  Start/Stop Unit                    
SCSI_LOAD_UNLOAD	EQU	1BH     ;  Tape Load/Unload Media             
SCSI_SEND_DIAGNOSTIC	EQU	1DH     ;  Send Diagnostic                    
SCSI_LOCK_UNLOCK	EQU	1EH     ;  Lock/Unlock drive door             
SCSI_READ_CAPACITY	EQU	25H     ;  Read Capacity                      
SCSI_READ_10	EQU	28H     ;  SCSI 10 byte Read                  
SCSI_WRITE_10	EQU	2AH     ;  SCSI 10 byte Write                 
SCSI_SEEK_10	EQU	2BH     ;  SCSI 10 byte Seek                  
SCSI_LOCATE	EQU	2BH     ;  Tape Locate                        
SCSI_WRITE_VERIFY_10	EQU	2EH     ;  SCSI 10 byte Write w/Verify        
SCSI_VERIFY_10	EQU	2FH     ;  SCSI 10 byte Verify                
SCSI_PREFETCH	EQU	34H     ;  Prefetch                           
SCSI_READ_SUB_CHAN	EQU	42H     ;  Read Sub-Channel (CD-ROM)          
SCSI_READ_TOC	EQU	43H     ;  Read Table of Contents             
SCSI_READ_HEADER	EQU	44H     ;  Read Header                        
SCSI_PLAY_AUDIO_10	EQU	45H     ;  Play Audio 10 byte                 
SCSI_PLAY_MSF	EQU	47H     ;  Play Audio - MSF format            
SCSI_PLAY_TRACK_INDEX	EQU	48H     ;  Play Audio - Track Index           
SCSI_PLAY_TRACK_REL	EQU	49H     ;  Play Audio - Track Relative        
SCSI_PAUSE_RESUME	EQU	4BH     ;  Pause/Resume Audio Play            
SCSI_MODE_SELECT_10	EQU	55H     ;  Mode Select - 10 byte              
SCSI_MODE_SENSE_10	EQU	5AH     ;  Mode Sense  - 10 byte              
SCSI_PLAY_AUDIO_12	EQU	0A5H     ;  Play Audio - 12 byte               
SCSI_READ_12	EQU	0A8H     ;  SCSI 12 byte read                  
SCSI_PLAY_TRACK_REL_12	EQU	0A9H     ;  Play Audio - Trace Relative 12     
; 
;*  SCSI Command Descriptor Block

SCSICDB6	STRUC
CDB6_Opcode	DB	?             ;  CDB Operation Code             
CDB6_Lun_MsbLBA	DB	?         ;  SCSI LUN & 5 MSB bits of LBA   
CDB6_MidLBA	DB	?             ;  SCSI MID byte of LBA           
CDB6_LsbLBA	DB	?             ;  SCSI LBA byte of LBA           
CDB6_XferLen	DB	?            ;  SCSI Xfer length, Alloc length   
CDB6_Control	DB	?            ;  Control byte                   
SCSICDB6	ENDS

SCSICDB10	STRUC
CDB10_Opcode	DB	?            ;  CDB Operation Code             
CDB10_Lun	DB	?               ;  SCSI                           
CDB10_LBA	DB	4 DUP (?)            ;  SCSI LBA MSB->LSB              
CDB10_Res	DB	?               ;  reserved byte                  
CDB10_XferLen	DB	2 DUP (?)        ;  SCSI Xfer length (MSB first)   
CDB10_Control	DB	?           ;  Control byte                   
SCSICDB10	ENDS

SCSICDB12	STRUC
CDB12_Opcode	DB	?            ;  CDB Operation Code             
CDB12_Lun	DB	?               ;  SCSI                           
CDB12_LBA	DB	4 DUP (?)            ;  SCSI LBA MSB->LSB              
CDB12_XferLen	DB	4 DUP (?)        ;  SCSI Xfer length (MSB first)   
CDB12_Res	DB	?               ;  reserved byte                  
CDB12_Control	DB	?           ;  Control byte                   
SCSICDB12	ENDS
; 
;* SCSI Status byte codes
SCSI_STAT_GOOD	EQU	00H       ;  Good status                    
SCSI_STAT_CHECKCOND	EQU	02H       ;  SCSI Check Condition           
SCSI_STAT_CONDMET	EQU	04H       ;  Condition Met                  
SCSI_STAT_BUSY	EQU	08H       ;  Target busy status             
SCSI_STAT_INTER	EQU	10H       ;  Intermediate status            
SCSI_STAT_INTERCONDMET	EQU	14H       ;  Intermediate condition met     
SCSI_STAT_RESCONFLICT	EQU	18H       ;  Reservation conflict           
SCSI_STAT_CMDTERM	EQU	22H       ;  Command Terminated             
SCSI_STAT_QUEUEFULL	EQU	28H       ;  Queue Full                     
; 
;*  Request Sense Data format

SCSIReqSenseData	STRUC
REQSEN_ErrCode_Valid	DB	?       ;  Error Code & Valid bit         
REQSEN_SegNum	DB	?              ;  Segment Number                 
REQSEN_SenseKey	DB	?            ;  Sense Key,ILI,EOM, FM          
REQSEN_INFO	DB	4 DUP (?)             ;  information field              
REQSEN_AddLen	DB	?              ;  additional length              
REQSEN_CmdInfo	DB	4 DUP (?)          ;  command-specific info          
REQSEN_AddSenseCode	DB	?        ;  additional sense code          
REQSEN_AddSenseCodeQual	DB	?    ;  additional sense code qualifier   
REQSEN_FieldRepUnitCode	DB	?    ;  field replaceable unit code    
REQSEN_KeySpecific	DB	3 DUP (?)      ;  Sense-key specific             
SCSIReqSenseData	ENDS
; 
;*  Sense Data bit masks
;  Byte 0 of sense data   
SCSI_ERRCODE_MASK	EQU	7FH             ;  Error Code                     
SCSI_VALID_MASK	EQU	80H             ;  Information field valid bit    
;  Byte 2 of sense data   
SCSI_SENSEKEY_MASK	EQU	0FH              ;  Sense key                    
SCSI_INCORRECT_LEN	EQU	20H             ;  Incorrect lenght indicator   
SCSI_SENSE_ENDOFMEDIUM	EQU	40H             ;  End-of-medium bit            
SCSI_SENSE_FM	EQU	80H             ;  filemark bit                 
; 
;*  Sense Key definitions
SCSI_SK_NOSENSE	EQU	0H      ;  No sense                       
SCSI_SK_RECERR	EQU	1H      ;  Recovered Error                
SCSI_SK_NOTRDY	EQU	2H      ;  Not Ready Error                
SCSI_SK_MEDIUMERR	EQU	3H      ;  Medium Error                   
SCSI_SK_HARDWAREERR	EQU	4H      ;  HardWare Error                 
SCSI_SK_ILLEGALREQ	EQU	5H      ;  Illegal Request                
SCSI_SK_UNITATTN	EQU	6H      ;  Unit Attention                 
SCSI_SK_DATAPROTECT	EQU	7H      ;  Data Protect Error             
SCSI_SK_BLANKCHK	EQU	8H      ;  Blank Check                    
SCSI_SK_COPYABORT	EQU	0AH     ;  Copy Aborted                   
SCSI_SK_ABORTEDCMD	EQU	0BH     ;  Aborted Command                
SCSI_SK_EQUAL	EQU	0CH     ;  Equal Comparison satisfied     
SCSI_SK_VOLOVERFLOW	EQU	0DH     ;  Volume Overflow                
SCSI_SK_MISCOMPARE	EQU	0EH     ;  Miscompare                     
; 
;*  Additional Sense Code definitions
ASC_NO_SEEK_COMPLETE	EQU	02H 
ASC_UNIT_NOT_READY	EQU	04H 
ASC_UNIT_COMM_FAIL	EQU	08H 
ASC_SERVO_FAIL	EQU	09H 
ASC_UNRECOVERED_ERROR	EQU	11H 
ASC_NO_ADDRESS_MARK	EQU	12H 
ASC_SEEK_POSITIONING_ERROR	EQU	15H 
ASC_DATA_SYNC_ERROR	EQU	16H 
ASC_INVALID_COMMAND_OPCODE	EQU	20H 
ASC_ILLEGAL_LBA	EQU	21H 
ASC_INVALID_FIELD	EQU	24H 
ASC_UNIT_NOT_SUPPORTED	EQU	25H 
ASC_INVALID_PARMLIST	EQU	26H 
ASC_MEDIUM_CHANGED	EQU	28H 
ASC_RESET	EQU	29H 
ASC_INCOMPATIBLE_CARTRIDGE	EQU	30H 
ASC_INTERNAL_TARGET_FAIL	EQU	44H 
ASC_TOC_RECOVERY_FAIL	EQU	57H 
ASC_END_USER_AREA	EQU	63H 
ASC_ILLEGAL_MODE_FOR_TRACK	EQU	64H 
ASCV_NOT_AUDIO_TRACK	EQU	88H 
ASCV_NOT_DATA_TRACK	EQU	89H 
ASCV_NOT_AUDIO_PLAY_STATE	EQU	8AH 
; 
;* SCSI IORB StatusBlock definition
SCSI_DIAGINFO_LEN	EQU	8 

SCSIStatusBlock	STRUC
STATBLK_Flags	DW	?                   ;  Status block flags             
STATBLK_AdapterErrorCode	DW	?        ;  Translated Adapter Error       
STATBLK_TargetStatus	DB	?            ;  SCSI status codes              
STATBLK_ResidualLength	DD	?          ;  Residual Length                
STATBLK_AdapterDiagInfo	DB	SCSI_DIAGINFO_LEN DUP (?) ;  Raw adapter status  
STATBLK_ReqSenseLen	DW	?             ;  amount of RS data requested    
STATBLK_SenseData	DD	?  ;  pointer to Req Sense Data      
SCSIStatusBlock	ENDS
;  Status Block flags definitions   
STATUS_SENSEDATA_VALID	EQU	0001H    ;  Sense Data Valid               
STATUS_RESIDUAL_VALID	EQU	0002H    ;  Residual Byte Count Valid      
STATUS_DIAGINFO_VALID	EQU	0004H    ;  Diagnostic Information Valid   
; 
;*  Inquiry Data format

SCSIInqData	STRUC
INQ_DevType	DB	?               ;  Periph Qualifier & Periph Dev Type  
INQ_RMB_TypeMod	DB	?           ;  rem media bit & Dev Type Modifier   
INQ_Vers	DB	?                  ;  ISO, ECMA, & ANSI versions          
INQ_RDF	DB	?                   ;  AEN, TRMIOP, & response data format  
INQ_AddLen	DB	?                ;  length of additional data           
INQ_Res1	DB	?                  ;  reserved                            
INQ_Res2	DB	?                  ;  reserved                            
INQ_Flags	DB	?                 ;  RelADr,Wbus32,Wbus16,Sync,etc.      
INQ_VendorID	DB	8 DUP (?)           ;  Vendor Identification               
INQ_ProductID	DB	16 DUP (?)         ;  Product Identification              
INQ_ProductRev	DB	4 DUP (?)         ;  Product Revision                    
SCSIInqData	ENDS
;   Inquiry byte 0 masks   
SCSI_DEVTYPE	EQU	1FH       ;  Peripheral Device Type               
SCSI_PERIPHQUAL	EQU	0E0H       ;  Peripheral Qualifier                 
;   Inquiry byte 1 mask   
SCSI_REMOVABLE_MEDIA	EQU	80H     ;  Removable Media bit (1=removable)    
;   Peripheral Device Type definitions   
SCSI_DASD	EQU	00H       ;  Direct-access Device           
SCSI_SEQACESS	EQU	01H       ;  Sequential-access device       
SCSI_PRINTER	EQU	02H       ;  Printer device                 
SCSI_PROCESSOR	EQU	03H       ;  Processor device               
SCSI_WRITEONCE	EQU	04H       ;  Write-once device              
SCSI_CDROM	EQU	05H       ;  CD-ROM device                  
SCSI_SCANNER	EQU	06H       ;  Scanner device                 
SCSI_OPTICAL	EQU	07H       ;  Optical memory device          
SCSI_MEDCHGR	EQU	08H       ;  Medium changer device          
SCSI_COMM	EQU	09H       ;  Communications device          
SCSI_NODEV	EQU	1FH       ;  Unknown or no device type      
; 
;* Inquiry flag definitions (Inq data byte 7)
SCSI_INQ_RELADR	EQU	80H     ;  device supports relative addressing  
SCSI_INQ_WBUS32	EQU	40H     ;  device supports 32 bit data xfers    
SCSI_INQ_WBUS16	EQU	20H     ;  device supports 16 bit data xfers    
SCSI_INQ_SYNC	EQU	10H     ;  device supports synchronous xfer     
SCSI_INQ_LINKED	EQU	08H     ;  device supports linked commands      
SCSI_INQ_CMDQUEUE	EQU	02H     ;  device supports command queueing     
SCSI_INQ_SFTRE	EQU	01H     ;  device supports soft resets   
SCSI_FORMAT_UNIT	EQU	04H 
