/**************************************************************************
 *
 * SOURCE FILE NAME =  RMLIB.H
 *
 * DESCRIPTIVE NAME =  RM function prototypes
 *
 *
 * Copyright : COPYRIGHT IBM CORPORATION, 1994, 1995
 *             LICENSED MATERIAL - PROGRAM PROPERTY OF IBM
 *             REFER TO COPYRIGHT INSTRUCTION FORM#G120-2083
 *             RESTRICTED MATERIALS OF IBM
 *             IBM CONFIDENTIAL
 *
 * VERSION = V1.01
 *
 * DATE
 *
 * DESCRIPTION :
 *
 * Purpose:
 *
 *
 *
 * FUNCTIONS  :
 *
 * NOTES
 *
 *
 * STRUCTURES
 *
 * EXTERNAL REFERENCES
 *
 *
 *
 * EXTERNAL FUNCTIONS
 *
 * CHANGE ACTIVITY =
 *   DATE      FLAG        APAR   CHANGE DESCRIPTION
 *   --------  ----------  -----  --------------------------------------
 *
 ****************************************************************************/

#ifndef __RM_LIB__
#define __RM_LIB__
#include <rmcalls.h>



#define    RMNAME                  "RESMGR$ "


/*********************/
/*  RMFlags          */
/*********************/
#define RM_CPL_RING3      0x0003

#define RMF_UNINITIALIZED   0x0000
#define RMF_INITIALIZED     0x0001
#define RMF_NO_RM           0x0002
#define RMF_INDEX_SAFE      0x0004
#define RMF_RESERVED_PNP1   0x0008
#define RMF_RESERVED_PNP2   0x0010


#define RMCALLBASE               0
#define RMRESERVED              (RMCALLBASE+0)
#define RMGETVERSION            (RMCALLBASE+1)
#define RMCREATEDRIVER          (RMCALLBASE+2)
#define RMDESTROYDRIVER         (RMCALLBASE+3)
#define RMCREATEADAPTER         (RMCALLBASE+4)
#define RMDESTROYADAPTER        (RMCALLBASE+5)
#define RMCREATEDEVICE          (RMCALLBASE+6)
#define RMDESTROYDEVICE         (RMCALLBASE+7)
#define RMALLOCRESOURCE         (RMCALLBASE+8)
#define RMDEALLOCRESOURCE       (RMCALLBASE+9)
#define RMCLAIMRESOURCES        (RMCALLBASE+10)
#define RMRELEASERESOURCES      (RMCALLBASE+11)
#define RMCREATELDEV            (RMCALLBASE+12)
#define RMDESTROYLDEV           (RMCALLBASE+13)
#define RMCREATESYSNAME         (RMCALLBASE+14)
#define RMDESTROYSYSNAME        (RMCALLBASE+15)
#define RMADDTOHDEVICE          (RMCALLBASE+16)
#define RMKEYTOHANDLELIST       (RMCALLBASE+17)
#define RMHANDLETOTYPE          (RMCALLBASE+18)
#define RMHANDLETOPARENT        (RMCALLBASE+19)
#define RMUPDATEADJUNCT         (RMCALLBASE+20)
#define RMADJTOHANDLELIST       (RMCALLBASE+21)
#define RMHDEVTOHLDEV           (RMCALLBASE+22)
#define RMRESTOHANDLELIST       (RMCALLBASE+23)
#define RMACTIVATEADAPTER       (RMCALLBASE+24)
#define RMDEACTIVATEADAPTER     (RMCALLBASE+25)
#define RMCREATELINKDEVICE      (RMCALLBASE+26)
#define RMMODIFYRESOURCES       (RMCALLBASE+27)
#define RMGETNODEINFO           (RMCALLBASE+28)
#define RMPARSESCSIINQUIRY      (RMCALLBASE+29)
#define RMCREATEDETECTED        (RMCALLBASE+30)
#define RMDESTROYDETECTED       (RMCALLBASE+31)
#define RMDEVIDTOHANDLELIST     (RMCALLBASE+32)
#define RMHTORESHANDLELIST      (RMCALLBASE+33)
#define RMMODIFYNODEFLAGS       (RMCALLBASE+34)
#define RMCONVERTID             (RMCALLBASE+35)
#define RMGETCOMMANDLINE        (RMCALLBASE+36)
#define RMSETSNOOPLEVEL         (RMCALLBASE+37)
#define RMSAVEDETECTEDDATA      (RMCALLBASE+38)
#define RMDELETEDETEDDATA       (RMCALLBASE+39)
/* Note add new RMAPIs here and update RMLASTCALL) */
#define RMLASTCALL              (RMCALLBASE+40)


#define RMTABLESIZE  RMLASTCALL


USHORT FAR  CallRM( USHORT RMIndex, PVOID pCallerParm );
USHORT NEAR GetCS(VOID);

#pragma alloc_text( RMCode, CallRM )
#pragma alloc_text( RMCode, GetCS )

#endif
